unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ActnList, XPMan, ImgList, ComCtrls, Menus, ToolWin;

type
  TMainForm = class(TForm)
    MainMenu: TMainMenu;
    ToolBar1: TToolBar;
    File1: TMenuItem;
    Edit1: TMenuItem;
    VIew1: TMenuItem;
    Help1: TMenuItem;
    OpenButton: TToolButton;
    SaveButton: TToolButton;
    ImageList: TImageList;
    ActionList: TActionList;
    XPManifest: TXPManifest;
    OpenAction: TAction;
    SaveAction: TAction;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Memo: TMemo;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    AboutAction: TAction;
    About1: TMenuItem;
    procedure AboutActionExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MemoChange(Sender: TObject);
    procedure OpenActionExecute(Sender: TObject);
    procedure SaveActionExecute(Sender: TObject);
  private
    { Private declarations }
    FChangedSinceSave: Boolean;
    function SaveHandled: Boolean;
    function SaveContents: Boolean;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses fAbout;

{$R *.dfm}

procedure TMainForm.AboutActionExecute(Sender: TObject);
begin
  AboutForm := TAboutForm.Create(Self);
  try
    AboutForm.ShowModal;
  finally
    FreeAndNil(AboutForm);
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := SaveHandled;
end;

procedure TMainForm.MemoChange(Sender: TObject);
begin
  FChangedSinceSave := True;
end;

function TMainForm.SaveHandled: Boolean;
begin
  Result := not FChangedSinceSave;
  if not Result then
  begin
    case MessageDlg('Would you like to save your changes?', mtConfirmation,
      [mbYes, mbNo, mbCancel], 0) of
      mrYes: Result := SaveContents;
      mrNo: Result := True;
    end;
  end;
end;

procedure TMainForm.OpenActionExecute(Sender: TObject);
begin
  if SaveHandled and OpenDialog.Execute then
  begin
    Memo.Lines.LoadFromFile(OpenDialog.FileName);
    FChangedSinceSave := True;
  end;
end;

function TMainForm.SaveContents: Boolean;
begin
  Result := False;
  if SaveDialog.Execute then
  begin
    Memo.Lines.SaveToFile(SaveDialog.FileName);
    FChangedSinceSave := True;
    Result := True;
  end;
end;

procedure TMainForm.SaveActionExecute(Sender: TObject);
begin
  SaveContents;
end;

end.
